#include "MyType.H"
#include "UsbCore.h"
#include "PDIUSBD12.h"
#include "SCSI.h"
#include "Uart.h"
#include "config.h"
#include "FAT.h"

//˵2Ϊ64ֽ
#define EP2_SIZE 64

//˵2ݵĻ
idata uint8 Ep2Buffer[EP2_SIZE];

uint32 ByteAddr;  //ֽڵַ

//INQUIRYҪص
//INQUIRYӦݸʽ
code uint8 DiskInf[36]=
{
 0x05, //CD ROM 豸
 0x80, //λD7ΪRMBRMB=0ʾƳ豸RMB=1ΪƳ豸
 0x00, //ְ汾0
 0x32, //Ӧʽ
 0x1F, //ݳȣΪ31ֽ
 0x00, //
 0x00, //
 0x00, //
 0xB5,0xE7,0XC4,0xD4,0xC8,0xA6,0xC8,0xA6, //̱ʶΪַȦȦ
 
 //ƷʶΪַԼļU̡
 0xD7,0xD4,0xBC,0xBA,0xD7,0xF6,0xB5,0xC4,0xBC,0xD9,0x55,0xC5,0xCC,0x00,0x00,0x00,
 0x31,0x2E,0x30,0x31 //Ʒ汾ţΪ1.01
};

//READ_CAPACITYҪص
code uint8 DiskCapacity[8]=
{
 0x00,0x01,0x83,0xD2, //ܹʵ߼ַ
 0x00,0x00,0x08,0x00  //ĳ 2048
};

//REQUEST SENSEҪصݣ̶Meduimû׼
code uint8 SenseData[18]=
{
 0x70, //룬̶Ϊ0x70
 0x00, //
 0x06, //Sense KeyΪ0x06ʾ Unit Attention
 0x00, 0x00, 0x00, 0x00, //InformationΪ0
 0x0A, //ݳΪ10ֽ
 0x00, 0x00, 0x00, 0x00, //
 0x28, //Additional Sense Code(ASC)Ϊ0x20ʾNot Ready To Ready Transition C Media Changed
 0x00, //Additional Sense Code Qualifier(ASCQ)Ϊ0
 0x00, 0x00, 0x00, 0x00 //
};

code uint8 TOCData[20]=
{
  0x00,0x12,0x01,0x01,0x00,0x14,0x01,0x00,
  0x00,0x00,0x02,0x00,0x00,0x14,0xAA,0x00,
  0x00,0x16,0x05,0x3A
};

code uint8 EventData[8]=
{
  0x00,0x06,0x04,0x5E,0x02,0x02,0x00,0x00
};

uint8 * pEp2SendData;
uint32 Ep2DataLength;

/********************************************************************
ܣCBWлȡݵֽ
ڲޡ
    أҪֽ
    עޡ
********************************************************************/
uint32 GetDataTransferLength(void)
{
 uint32 Len;
 
 //CBW[8]~CBW[11]Ϊ䳤ȣС˽ṹ
 
 Len=CBW[11];
 Len=Len*256+CBW[10];
 Len=Len*256+CBW[9];
 Len=Len*256+CBW[8];
 
 return Len;
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣCBWлȡ߼ַLBAֽ
ڲޡ
    أ߼ַLBA
    עޡ
********************************************************************/
uint32 GetLba(void)
{
 uint32 Lba;
 
 //дʱCBW[17]~CBW[20]Ϊ߼ַ˽ṹ
 
 Lba=CBW[17];
 Lba=Lba*256+CBW[18];
 Lba=Lba*256+CBW[19];
 Lba=Lba*256+CBW[20];
 
 return Lba;
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣCSW
ڲResidueʣֽStatusִе״̬
    أޡ
    עޡ
********************************************************************/
void SetCsw(uint32 Residue, uint8 Status)
{
 //CSWǩʵԲÿζõģ
 //ʼʼһξˣÿζ
 CSW[0]='U';
 CSW[1]='S';
 CSW[2]='B';
 CSW[3]='S';
 
 //dCBWTagCSWdCSWTagȥ
 CSW[4]=CBW[4];
 CSW[5]=CBW[5];
 CSW[6]=CBW[6];
 CSW[7]=CBW[7];
    
 //ʣֽ
 CSW[8]=Residue&0xFF;
 CSW[9]=(Residue>>8)&0xFF;
 CSW[10]=(Residue>>16)&0xFF;
 CSW[11]=(Residue>>24)&0xFF;
 
 //ִе״̬0ʾɹ1ʾʧܡ
 CSW[12]=Status;
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣȡݺ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void GetDiskData(void)
{
 //жϸ÷ʲô
 if(ByteAddr<0x7800) pEp2SendData=Zeros;
 if((ByteAddr>=0x7800)&&(ByteAddr<=0x783f)) pEp2SendData=cddata1; 
 if((ByteAddr>=0x7840)&&(ByteAddr<=0x7fff)) pEp2SendData=Zeros;
 if((ByteAddr>=0x8000)&&(ByteAddr<=0x80BF)) pEp2SendData=(cddata2a+ByteAddr-0x8000);  
 if((ByteAddr>=0x80C0)&&(ByteAddr<=0x81FF)) pEp2SendData=space;  
 if((ByteAddr>=0x8200)&&(ByteAddr<=0x827f)) pEp2SendData=(cddata2b+ByteAddr-0x8200);
 if((ByteAddr>=0x8280)&&(ByteAddr<=0x82FF)) pEp2SendData=space;
 if((ByteAddr>=0x8300)&&(ByteAddr<=0x837F)) pEp2SendData=(cddata2c+ByteAddr-0x8300);     
 if((ByteAddr>=0x8380)&&(ByteAddr<=0x87ff)) pEp2SendData=Zeros;
 
 if((ByteAddr>=0x8800)&&(ByteAddr<=0x883f)) pEp2SendData=(cddata3+ByteAddr-0x8800); 
 if((ByteAddr>=0x8840)&&(ByteAddr<=0x8fff)) pEp2SendData=Zeros;
 if((ByteAddr>=0x9000)&&(ByteAddr<=0x90ff)) pEp2SendData=(cddata4+ByteAddr-0x9000); 

 if((ByteAddr>=0x9100)&&(ByteAddr<=0x97ff)) pEp2SendData=Zeros;
 if((ByteAddr>=0x9800)&&(ByteAddr<=0x983f)) pEp2SendData=(cddata5+ByteAddr-0x9800); 
 if((ByteAddr>=0x9840)&&(ByteAddr<=0x9fff)) pEp2SendData=Zeros;
 if((ByteAddr>=0xa000)&&(ByteAddr<=0xa03f)) pEp2SendData=(cddata6+ByteAddr-0xa000); 

 if((ByteAddr>=0xa040)&&(ByteAddr<=0xa7ff)) pEp2SendData=Zeros;
 if((ByteAddr>=0xa800)&&(ByteAddr<=0xadff)) pEp2SendData=(cddata7+ByteAddr-0xa800); 
 
 if((ByteAddr>=0xae00)&&(ByteAddr<=0xafff)) pEp2SendData=Zeros;
 if((ByteAddr>=0xb000)&&(ByteAddr<=0xb03f)) pEp2SendData=(cddata8+ByteAddr-0xb000); 

 if((ByteAddr>=0xb040)&&(ByteAddr<=0xb7ff)) pEp2SendData=Zeros;
 if((ByteAddr>=0xb800)&&(ByteAddr<=0xb83f)) pEp2SendData=(cddata9+ByteAddr-0xb800); 

 if (ByteAddr>=0xb840) pEp2SendData=Zeros;
 ByteAddr+=EP2_SIZE; //ֽڵַÿηȵ
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣͨ˵2͡
ڲޡ
    أޡ
    עݳΪ0Ҵݽ׶ʱԶCSW
********************************************************************/
void Ep2SendData(void)
{
 if(Ep2DataLength==0) //Ҫ͵ݳΪ0
 {
  if(TransportStage==DATA_STAGE) //Ҵݽ׶
  {
   //ֱӽ״̬׶
   TransportStage=STATUS_STAGE;
   Ep2DataLength=sizeof(CSW); //ݳΪCSWĴС
   pEp2SendData=CSW; //صΪCSW
  }
  else
  {
   return; //״̬׶εݷϣ򷵻
  }
 }
 
#ifdef DEBUG0
#ifdef DEBUG3
 if(TransportStage==STATUS_STAGE)
 {
  Prints("״̬׶Ρ\r\n");
 }
#endif		 
#endif
   

 //Ҫ͵ĳȱȶ˵2Ҫֶ࣬
 if(Ep2DataLength>EP2_SIZE)
 {
  //Ͷ˵2󳤶ֽ
  D12WriteEndpointBuffer(5,EP2_SIZE,pEp2SendData);
  //ָƶEP2_SIZEֽ
  pEp2SendData+=EP2_SIZE;
  Ep2DataLength-=EP2_SIZE;
  //READ(10)ݽ׶ΣҪȡ
  if((CBW[15]==READ_10)&&(TransportStage==DATA_STAGE))
  {
   GetDiskData(); //ȡ
  }
 }
 else
 {
  //ȫ
  D12WriteEndpointBuffer(5,(uint8)Ep2DataLength,pEp2SendData);
  Ep2DataLength=0;  //䳤Ϊ0  
  //ݷϣЭ״̬׶
  if(TransportStage==DATA_STAGE)
  {
   TransportStage=STATUS_STAGE;
   Ep2DataLength=sizeof(CSW); //ݳΪCSWĴС
   pEp2SendData=CSW; //صΪCSW
  }
  else if(TransportStage==STATUS_STAGE) //״̬׶ϣ뵽׶
  {
   TransportStage=COMMAND_STAGE;  //뵽׶
  }
 }
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣSCSIĺ
ڲޡ
    أޡ
    עȻSCSIʵʹõUFI
********************************************************************/
void ProcScsiCommand(void)
{
 TransportStage=DATA_STAGE; //뵽ݽ׶
 
 //CBWƫΪ15ֶΪ
 switch(CBW[15])
 {
  case INQUIRY:  //INQUIRY
  #ifdef DEBUG0
  #ifdef DEBUG3
   Prints("ѯݣ\r\n");
  #endif
  #endif
   pEp2SendData=DiskInf; //شϢ
   Ep2DataLength=GetDataTransferLength(); //ȡҪصĳ
   SetCsw(Ep2DataLength-sizeof(DiskInf),0); //ʣֽԼ״̬ɹ
   if(Ep2DataLength>sizeof(DiskInf)) //ݱʵʵҪ
   {
    Ep2DataLength=sizeof(DiskInf); //ֻʵʵĳ
   }
   Ep2SendData(); //
  break;
  
  case READ_CAPACITY: //
  #ifdef DEBUG0
  #ifdef DEBUG3
   Prints("ݣ\r\n");
  #endif
  #endif
   pEp2SendData=DiskCapacity; //ش
   Ep2DataLength=GetDataTransferLength(); //ȡҪصĳ
   SetCsw(Ep2DataLength-sizeof(DiskCapacity),0); //ʣֽԼ״̬ɹ
   if(Ep2DataLength>sizeof(DiskCapacity)) //ݱʵʵҪ
   {
    Ep2DataLength=sizeof(DiskCapacity); //ֻʵʵĳ
   }
   Ep2SendData(); //
  break;
  
  case READ_10: //READ(10)
  #ifdef DEBUG0
   Prints("READ(10)ݣ\r\n");
  #endif
   Ep2DataLength=GetDataTransferLength(); //ȡҪصĳ
   ByteAddr=GetLba()*2048;//ZivDebug  //ȡֽڵַֽڵַΪ߼ַÿС
   SetCsw(0,0); //ʣֽΪ0״̬ɹ
  #ifdef DEBUG0
   Prints("length  ");
   PrintLongInt(Ep2DataLength);
   Prints("\r\n");
   Prints("address  ");
   PrintLongInt(ByteAddr/2048);
   Prints("\r\n");
  #endif

   GetDiskData(); //ȡҪص
   Ep2SendData(); //
  break;
  
  case WRITE_10: //WRITE(10)
  #ifdef DEBUG0
  #ifdef DEBUG3
   Prints("WRITE(10)ݣ\r\n");
  #endif
  #endif
   Ep2DataLength=GetDataTransferLength(); //ȡҪصĳ
   SetCsw(0,0); //ʣֽΪ0״̬ɹ
  break;
  
  case REQUEST_SENSE: //ѯǰһִʧܵԭ
  #ifdef DEBUG0
  #ifdef DEBUG3
   Prints("REQUEST SENSESENSEݣЧ\r\n");
  #endif
  #endif
   pEp2SendData=SenseData; //̽
   Ep2DataLength=GetDataTransferLength(); //ȡҪصĳ
   SetCsw(Ep2DataLength-sizeof(SenseData),0); //ʣֽԼ״̬ɹ
   if(Ep2DataLength>sizeof(SenseData)) //ݱʵʵҪ
   {
    Ep2DataLength=sizeof(SenseData); //ֻʵʵĳ
   }
   Ep2SendData(); //
  break;
  
  case TEST_UNIT_READY: //ԴǷ׼
   Ep2DataLength=0; //óΪ0ݽCSW
   SetCsw(0,0); //CSWΪɹ
   Ep2SendData(); //CSW
  break;
  
  case READ_TOC: //ȡùTOC
   pEp2SendData=TOCData; //شϢ
   Ep2DataLength=GetDataTransferLength(); //ȡҪصĳ
   SetCsw(Ep2DataLength-sizeof(TOCData),0); //ʣֽԼ״̬ɹ
   if(Ep2DataLength>sizeof(TOCData)) //ݱʵʵҪ
   {
    Ep2DataLength=sizeof(TOCData); //ֻʵʵĳ
   }
   Ep2SendData(); //
   break;

  case GET_EVENT_STATUS: //ȡ Event Notifycation 
   pEp2SendData=EventData; //شϢ
   Ep2DataLength=GetDataTransferLength(); //ȡҪصĳ
   SetCsw(Ep2DataLength-sizeof(EventData),0); //ʣֽԼ״̬ɹ
   if(Ep2DataLength>sizeof(EventData)) //ݱʵʵҪ
   {
    Ep2DataLength=sizeof(EventData); //ֻʵʵĳ
   }
   Ep2SendData(); //
  break;

  default: //ϣִʧ
   if(CBW[12]&0x80) Ep2DataLength=1; //Ϊ㷵1ֽ
   else Ep2DataLength=0; //ΪóΪ0ֱӷCSW
   SetCsw(GetDataTransferLength()-Ep2DataLength,1); //CSWΪʧ
   Ep2SendData(); //CSW
  break;
 }
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣݡ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void ProcScsiOutData(void)
{
 uint8 Len;
 //˵2
 Len=D12ReadEndpointBuffer(4,EP2_SIZE,Ep2Buffer);
 Ep2DataLength-=Len;
 //˵㻺
 D12ClearBuffer();
 //ûд洢ｫ0ģݴ
 while(Len)
 {
  Ep2Buffer[Len]=0; //0
  Len--;
 }
 
 //ݴϣ뵽״̬׶
 if(Ep2DataLength==0)
 {
  //ʱEp2DataLengthΪ0Ҵݽ׶Σ÷ݺCSW
  Ep2SendData();
 }
}
////////////////////////End of function//////////////////////////////