#ifndef __USBCORE_H__
#define __USBCORE_H__

#define GET_STATUS         0
#define CLEAR_FEATURE      1
#define SET_FEATURE        3
#define SET_ADDRESS        5
#define GET_DESCRIPTOR     6
#define SET_DESCRIPTOR     7
#define GET_CONFIGURATION  8
#define SET_CONFIGURATION  9
#define GET_INTERFACE      10
#define SET_INTERFACE      11
#define SYNCH_FRAME        12

#define DEVICE_DESCRIPTOR         1
#define CONFIGURATION_DESCRIPTOR  2
#define STRING_DESCRIPTOR         3
#define INTERFACE_DESCRIPTOR      4
#define ENDPOINT_DESCRIPTOR       5
#define REPORT_DESCRIPTOR         0x22

#define SET_IDLE 0x0A


#define GET_MAX_LUN  0xFE
#define MASS_STORAGE_RESET 0xFF

#define COMMAND_STAGE 0x00
#define DATA_STAGE    0x01
#define STATUS_STAGE  0x02

void UsbDisconnect(void); //USBϿ
void UsbConnect(void);    //USB
void UsbBusSuspend(void); //߹жϴ
void UsbBusReset(void);   //߸λжϴ
void UsbEp0Out(void);     //˵0жϴ
void UsbEp0In(void);      //˵0жϴ
void UsbEp1Out(void);     //˵1жϴ
void UsbEp1In(void);      //˵1жϴ
void UsbEp2Out(void);     //˵2жϴ
void UsbEp2In(void);      //˵2жϴ

extern uint8 ConfigValue;  //ǰֵ
extern uint8 Ep1InIsBusy;  //˵1Ƿæ
extern uint8 Ep2InIsBusy;  //˵2Ƿæ

extern idata uint8 CBW[31];
extern idata uint8 CSW[13];
extern uint8 TransportStage;

#endif